prog::testinit("qShiftOp",  275.4 ):

test_helpers              := TRUE:
test_baserep              := not TRUE;
test_lclm                 := not TRUE:
test_basic_arithmetic     := not TRUE:
test_polynomial_solutions := not  TRUE:
test_random_polysols      := not  TRUE:
test_rational_solutions   :=   TRUE:
test_random_ratsols       :=   TRUE:

mytest := proc(m) 
begin 
  eval(hold(prog::testfunc)(_concat(args()))): 
  print(Unquoted, _concat("*** Testing: ", args())): 
end_proc:

//mytest(Dom::qShiftOperators):

//////////////////////////////////////////////////////////////////////////////
mytest("constructors"):

prog::test(domtype((R := Dom::qShiftOperators())), DOM_DOMAIN):

//////////////////////////////////////////////////////////////////////////////
// helpers -- findshift
if test_helpers then
  mytest("helpers -- findshift"):
  SEED := 34839:
  rand := random(0..100):
  for i from 3 to 50 do
  	p1 := expr(polylib::randpoly([x,q], Degree=2*i, Terms=i)):
  	k := rand():
  	p2 := R::qShift(p1, k);
  	p3 := expr(polylib::randpoly([x,q], Degree=2*i, Terms=i));
  	prog::test(R::findshift(p1, p2), k):
  	prog::test(R::findshift(p2, p1), -k):
  	prog::test(R::findshift(p1, p3), FAIL):
  end_for;

  // helpers -- baserep
  if test_baserep then
    mytest("helpers -- baserep"):
    SEED := 231:
    [p1, p2, p3, p4, p5] := [ normal(polylib::primpart(expr(polylib::randpoly([x,q])),[x])) $ i = 1..5]:
    P1 := poly(p1 * p2 * R::qShift(p2, 2) * p3 * p4, [x,q]):
    P2 := poly(p2 * R::qShift(p3, 3) * p4^2 * p5, [x,q]):
    prog::test(nops(([base, rep, B] := R::baserep(P1, P2))), 3):
    g := combinat::cartesisianProduct:generator(base, base):
    while FAIL <> (p := g()) do prog::test(R::findshift(p[1],p[2]), FAIL) end_while:
    delete p, g;
    prog::test(B, [0,3]):
    prog::test(traperror((
      PP1 := rep[1][1] * _mult(_mult(R::qShift(expr(b),a[1])^a[2] $ a in rep[1][2][b]) $ b in base);
      PP2 := rep[2][1] * _mult(_mult(R::qShift(expr(b),a[1])^a[2] $ a in rep[2][2][b]) $ b in base);
      )), 0):
    prog::test(poly(normal(PP1),[x,q]), P1);
    prog::test(poly(normal(PP2),[x,q]), P2);
  end_if;
end_if: // test_helpers

//////////////////////////////////////////////////////////////////////////////
// creating elements
mytest("creating elements"):

prog::test(R::order((L1 := R(((2*x + 1)/((2*q)*x^2 - 2*q))*Eq^2 + (x + q^2)*Eq + (((-q^2)*x + 1)/(x^2 + q^2*x))))), 2):
prog::test(R::order((L2 := R(((1)/(x))*Eq^2 + ((-q)*x^6)*Eq + (x + 3)))), 2):
prog::test(R::order((L3 := R(Eq + q*x + 3))), 1):
prog::test(R::order((L4 := R(Eq^2 + (x + q^2)*Eq + (-q^2)*x + 1))), 2):
prog::test(R::order((L5 := R(Eq^2 + ((-q)*x^6)*Eq + (x + 3)))), 2):

// basic arithmetic
if test_basic_arithmetic then
  mytest("basic arithmetic"):

  prog::test(R::order((L10 := L1 * L2)), 4):
  prog::test(R::order((L11 := L2 * L1)), 4):
  prog::test(R::order((L12 := L4 * L3)), 3):
  prog::test(R::order((L13 := L5 * L3)), 3):
  prog::test(R::order((L14 := L3 * L4)), 3):
  prog::test(R::order((L15 := L3 * L5)), 3):
  prog::test(R::iszero(L1 - L1), TRUE):
  prog::test(R::iszero(L2 - L2), TRUE):
  prog::test(R::order((L2 + L1)), 2):
  prog::test(R::iszero((L1+L2)-(L2+L1)), TRUE):
  prog::test(R::iszero((L1*L2)-(L2*L1)), FALSE):

  // right-arithmetic
  prog::test(traperror((Sol := R::rightdivide(L10,L2))), 0):
  prog::test(iszero(Sol[1]-L1) and iszero(Sol[2]), TRUE):
  prog::test(traperror((Sol := R::rightdivide(L11,L1))), 0):
  prog::test(iszero(Sol[1]-L2) and iszero(Sol[2]), TRUE):
  prog::test(traperror((Sol := R::rightdivide((L11+R(1)),L1))), 0):
  prog::test(iszero(Sol[1]-L2) and iszero(Sol[2]-R(1)), TRUE):
  prog::test(traperror((Sol := R::gcrd(L12, L13))), 0):
  prog::test(iszero(Sol-L3), TRUE):

  // left-arithmetic
  prog::test(traperror((Sol := R::leftdivide(L10,L1))), 0):
  prog::test(iszero(Sol[1]-L2) and iszero(Sol[2]), TRUE):
  prog::test(traperror((Sol := R::leftdivide(L11,L2))), 0):
  prog::test(iszero(Sol[1]-L1) and iszero(Sol[2]), TRUE):
  prog::test(traperror((Sol := R::leftdivide((L11+R(1)),L2))), 0):
  prog::test(iszero(Sol[1]-L1) and iszero(Sol[2]-R(1)), TRUE):

  // lclm
  if test_lclm then
    prog::test(traperror((Sol := R::lclm(L1, L2))), 0):
    prog::test(R::degree(Sol), 4):
    prog::test(iszero((R::rightdivide(Sol, L1))[2]), TRUE):
    prog::test(iszero((R::rightdivide(Sol, L2))[2]), TRUE):
    prog::test(traperror((Sol := R::lclm(L5, L4))), 0):
    prog::test(R::degree(Sol), 4):
    prog::test(iszero((R::rightdivide(Sol, L5))[2]), TRUE):
    prog::test(iszero((R::rightdivide(Sol, L4))[2]), TRUE):
  end_if: // test_lclm

end_if: // test_basic_arithmetic

// polynomial solutions
if test_polynomial_solutions then
  mytest("polynomial solutions of order 1"):
  for i from 1 to 10 do
    p := polylib::randpoly([x,q],Degree=i):
    L := R(expr(p)*Eq-subs(expr(p),x=q*x)):
    qT := qT.[L];
    prog::test(nops((Sol := R::qpolysols(L))), 1): 
    prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
  end_for:

  if test_random_polysols then
    mytest("polynomial solutions of higher order operators"):
    for ord from 2 to 7 do
      mytest("polynomial solutions of order ", ord," operators"):
      p := polylib::randpoly([x,q], Degree=5):
      L0 := R(expr(p)*Eq-subs(expr(p),x=q*x)):
      L := L0;
    	j := ord;
      for j from 1 to ord do
        pp := expr(polylib::randpoly(Degree=2)):
        prog::test(R::order((L := L + R(pp*Eq)*L)), j+1):
        qT := qT.[L];
        prog::test(nops((Sol := R::qpolysols(L))), 1): 
        prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
      end_for;
    end_for:
  end_if: // test_random_polysols
end_if: // test_polynomial_solutions

// rational solutions
if test_rational_solutions then
  mytest("rational solutions"):

  prog::test(R::ratsols(R(q*x*Eq-x)), {1/x}):
  p1:=q^2*x^2+x+1:
  p2:=x-q*x-2:
  L:=R::polyfy(R(expr(p1)/expr(p2)*Eq-expr(R::qShift(expr(p1),1))/expr(R::qShift(expr(p2),1))))[1]:
  prog::test(nops((Sol := R::ratsols(L))), 1):
  prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
  
  if test_random_ratsols then
    mytest("rational solutions of random operators"):
    for ord from 2 to 3 do
      mytest("rational solutions of order ", ord):
      p := polylib::randpoly([x,q],Degree=2,Terms=2):
      r := polylib::randpoly([x,q],Degree=2,Terms=2):
      L0 := R(expr(p)/expr(r)*Eq-expr(R::qShift(expr(p),1))/expr(R::qShift(expr(r),1))):
      L := L0;
      for j from 1 to ord do
        qq := expr(polylib::randpoly([x,q], Degree=2, Terms=2)):
        prog::test(R::order((L := L + R(qq*Eq)*L)), j+1):
      end_for;
      Sol := "MUFF";
      L := R::polyfy(L)[1];
      prog::test(nops((Sol := R::ratsols(L))), 1): 
      if Sol="MUFF" then
        print(L);
        error("muff");
      end_if;
      prog::test(map(Sol, (y)->(simplify(L(y)))), {0}):
    end_for;
  end_if: // test_random_ratsols
end_if:

prog::testexit():
