/*
   reset():read("dumbrat2.mu"):n:=3:r:=()->expr(polylib::randpoly([X])+Y*polylib::randpoly([X])):M := matrix([[r() $ i=1..n]$j=1..n]):b := matrix([[r()]$i=1..n]):
4.5.0 > M := matrix([[r() $ i=1..n]$i=1..n]):
4.5.0 > deeet(M)
The Bounds are: X=41  Y=17  Z=9  
Need to compute 6273 modular determinants.
Computing modular determinants: 
modular determinants took  75.34sec.
interpolating...

*/

liinalg := newDomain("liinalg"):
liinalg::interface := {}:
//------------------------------------------------------
// First try, using cramer's rule
// often faster that linalg::matlinsolve but not very
// clever, though
//------------------------------------------------------
liinalg::dumblinsoolve := proc(M, b)
local n, soldenom, i, di;
begin
  n := extop(M,1);
  soldenom := liinalg::rdet(M);
  di := [liinalg::rdet(linalg::setCol(M, i, b)) $ i=1..n];
  matrix([[normal(di[i]/soldenom)] $ i=1..n]);
end_proc:

liinalg::linsolve := proc(eq, var) 
local i, M, b, s, v;
begin
  var := [op(var)];
  eq := [map(op(eq), poly, var)];
  if {op(map(eq, degree))} <> {1} then
    error("Expecting a linear system"):
  end_if;
  M := matrix([ [ expr(coeff(eq[i], v, 1)) $ v in var ] $ i=1..nops(eq) ]);
  b := [ expr(ground(eq[i])) $ i=1..nops(eq) ];
  if { map(op(b), iszero) } = {TRUE} then
    for i from 1 to nops(eq) do
      g := lcm(denom(M[i,j]) $ j=1..nops(var));
      M := linalg::multRow(M, i, g);
    end_for;
    M := map(M, normal);
    S := liinalg::nullspace_multiv(M)
  else
    b := matrix([ [ b[i] ] $ i=1..nops(eq) ]);
    S := liinalg::matlinsolve(M, b);
  end_if;
  map(S, m -> [var[i] = m[i,1] $ i=1..nops(var)]);
end_proc:

liinalg::nullspace_multiv := proc(M)
local J, MM, Mpol, Pos, X, bound, i, j, l, nc, nr, pt, tmp, x,
  B, DET, Det, LUp, Mp, NS, R, Rks, Sol, b, charcols, d, den, k, modSol, r, rk, 
  tt, Ns, ns, CP, L, P, SSol, U, dd, found;
begin
  X := [op(indets(M))];
  nr := linalg::nrows(M);
  nc := linalg::ncols(M);
  Mpol := map(M, poly, X);
  rk := -infinity;
  J := 0;
  found := [];
  while TRUE do
    pt := (-1)^J * floor((J+1)/2);
    MM := map(Mpol, (A)->_if(iszero(A),0,evalp(A, [x=pt $ x in X])));    
//    MM := map(Mpol, evalp, [x=pt $ x in X]);
    tmp := linalg::gaussJordan(MM, All);
    if tmp[2] > rk then
      rk := tmp[2];
      found := [[pt, MM, tmp]];
      if rk = nr then break end;
    elif tmp[2] = rk then
      found := found.[ [pt, tmp] ];
      if nops(found) = 3 then break end;
    end_if;
    J := J + 1;
  end_while;
  // ne now assume, that rk is the actual rank of the Matrix M
  [pt, MM, tmp] := found[1];
  charcols := [op(tmp[4])];
  tmp := linalg::gaussJordan(linalg::transpose(MM), All);
  Mpol := linalg::delRow(Mpol, [op({i $ i=1..nr} minus { op(tmp[4]) })]);
  nr := linalg::nrows(Mpol);
  nc := linalg::ncols(Mpol);
  // now, MM should have 'full' rank nr
  // compute bound on the degree
  bound := table(x = 1+nc*max(max(degree(Mpol[i,j], x) $ j=1..nc) $ i=1..nr) $ x in X);
  //print("Grad-Schranke: ".bound);
  // get the 'characteristic' matrix
  MM := linalg::concatMatrix(op(linalg::col(Mpol, charcols)));
  DET := liinalg::det(MM, X);
  Pos := liinalg::evalPoints(X, bound, DET);
  CP := combinat::cartesianProduct(bound[x] $ x in X);
  J := { j $ j=1..nc } minus { op(charcols) };
  modSol := table(i=array(1..bound[x] $ x in X) $ i in J);
  for l in CP do
    //print(l);
    pt := [Pos[i][l[i]] $ i=1..nops(l)];
    Mp := map(MM, (A)->_if(iszero(A), 0, evalp(A, [X[i]=pt[i] $ i=1..nops(X)])));
    //MM := map(Mpol, (A)->_if(iszero(A),0,evalp(A, [x=pt $ x in X])));    
    [L,U,P] := linalg::factorLU(Mp);
    dd := map(DET, evalp, [X[i]=pt[i] $ i=1..nops(X)]);
    for k in J do
      B := matrix([[Mpol[j,k]] $ j in P]);
      b := map(B, evalp, [X[i]=pt[i] $ i=1..nops(X)]);
      tmp := linalg::matlinsolveLU(L, U, (-1)*b);
      modSol[k][op(l)] := [dd/denom(tmp[i,1])*numer(tmp[i,1]) $ i=1..nops(charcols)];
    end_for;
  end_for;
  //
  Sol := {}; 
  //print("So, interpolieren!");
  for k in J do
    tmp := table(charcols[i] = expr(interpolate(Pos, map(modSol[k], op, i), X)) $ i=1..nops(charcols));
    tmp[k] := expr(DET);
    Sol := Sol union { matrix(nc, 1, tmp) };
  end_for;
  Sol;
end_proc:

liinalg::nullspace := liinalg::nullspace_multiv:

// M needs to have DOM_POLY entries
liinalg::matrixSquarify := proc(M, b, X)
local nr, nc, MM, M2, i, j, rnd, rr, rk, ns, Ns, NS, R, deltdrows, m, LL, L, l, n, det, evalpoints;
save r;
begin
  delete r;
  deltdrows := [];
  nr := extop(M,1);
  nc := extop(M,2);
  rnd := random(-100..100);
  rr := [ 0, 1, -1, (rnd() $ i=1..nops(X)) $ j=1..5 ];
  MM := [ map(M, (m)->m(op(r))) $ r in rr ];
  rk := map(MM, linalg::rank);
  if _lazy_and((nr > r) $ r in rk) then
    if _lazy_or(max(op(rk))<linalg::rank(MM[r].(map(b, (m)->m(op(rr[r]))))) $ r=1..5) then 
      return([FAIL, FAIL, FAIL]); 
    end_if;
  end_if;
  tmp := select([ i $ i=1..7 ], (r) -> bool(rk[r]=max(op(rk))));
  MM := [MM[i] $ i in tmp];
  rk := [rk[i] $ i in tmp];
  while _lazy_and((nr > r) $ r in rk) do
    // suppose the rows don't have full rank
    NS := map(MM, linalg::nullspace@linalg::transpose);
    R := select({i $ i=1..nr}, (j)->_lazy_and(_lazy_or(not iszero(ns) $ ns in Ns) $ Ns in NS));
    r := op(R, 1);
    deltdrows := deltdrows.[r];
    MM := map(MM, linalg::delRow, r);
    M := linalg::delRow(M, r);
    nr := nr-1;
    rk := map(MM, linalg::rank);
  end_while;
  // MM := linalg::transpose(MM):
  // while _lazy_and((nc > r) $ r in rk) do
  //   // suppose the columns don't have full rank
  //   NS := map(MM, linalg::nullspace);
  //   R := select({i $ i=1..nr}, (j)->_lazy_and(_lazy_or(not iszero(ns) $ ns in Ns) $ Ns in NS));
  //   r := op(R, 1);
  //   deltdcols := deltdcols.[r];
  //   MM := map(MM, linalg::delRow, r);
  //   M := linalg::delCol(M, r);
  //   nc := nc-1;
  //   rk := map(MM, linalg::rank);
  // end_while;
  // MM := linalg::transpose(MM):
  // now, the rows that are actually present should be lineary independent
  //map(MM, linalg::transpose)
  NS := map(MM, linalg::nullspace);
  ns := op(select([i $ i=1..nops(NS)], (j)->bool(nops(NS[j]) = nc-nr)), 1);
  NS := NS[ns];
  pt := rr[ns];
  MM := MM[ns];
  L := [[ns[i,1] $ i=1..nc] $ ns in NS];
  L := map(L, (m)->(map(m, _mult, lcm(denom(j) $ j in m))));
  st := time():
  LL := FAIL;
  for i from 1 to nops(NS) do
    rnd := _if(i<=2, random(-i..i), random(-(5*i)..(5*i)));
    LL := [ [_if( abs(j) > 3*i, rnd(), j) $ j in l] $ l in L ];
    M2 := linalg::stackMatrix(MM, matrix([j]) $ j in LL);
    if linalg::rank(M2) < nr then 
      LL := FAIL ;
      print(NoNL, ".");
    else
      break
    end_if
  end_for;
  if LL = FAIL then 
    LL:=L; 
  end_if;
  MM := linalg::stackMatrix(M, matrix([j]) $ j in LL);
  det := poly(liinalg::det(MM, X), X);
  liinalg::pprint(Unqoted, "computed determinant in ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  return([MM, deltdrows, nc-nr, det]);
end_proc:

liinalg::matlinsolve := proc(M, b) 
local Mpol, Pos, S, X, bound, bpol, denombound, i, j, l, modSol, n, needed, nn, p, pt, st, tmp, x, den, MM, bb, CP, L, U, Perm, soldim, dd, deltdrows, nc, nr;
save TEXTWIDTH;
begin
  X := [op(indets(M) union indets(b))];
  // convert the whole thing to poly-Entries
  Mpol := map(M, poly, X);
  bpol := map(b, poly, X);
  if has(Mpol, FAIL) or has(bpol, FAIL) then error("matrix with polynomial expression enties expected.") end_if;
  // Square-dance
  [M, deltdrows, soldim, denombound] := liinalg::matrixSquarify(Mpol, bpol, X);
  if M=FAIL then return([]) end_if;

  nr := extop(M,1);
  nc := extop(M,2);
  if nr = nc and soldim=0 then
    liinalg::pprint(Unqoted, "Got a square Matrix of dimension ".nr." and full rank.");
    return(liinalg::matlinsolve_square_fullrank(Mpol,bpol,X,denombound));
  end_if;
  
  // delete the appropriate rows of B, too
  for i in deltdrows do bpol := linalg::delRow(bpol, i) end_for;
  // maximal degree for the numerator of an coefficient of the solution
  bound := table( x = 1+_plus(max(degree(Mpol[i,j], x) $ j=1..n, degree(bpol[i,1], x)) $ i=1..n) $ x in X);
  liinalg::pprint(Unquoted, "The Bounds are: "._concat(expr2text(x)."=".bound[x]."  " $ x in X));
  // worst possible denominator
  st := time():
  i := -1; p := 0;
  Pos := liinalg::evalPoints(X, bound, denombound);
  //[[(-1)^i * floor((i+1)/2) $ i=1..bound[x]] $ x in X];
  modSol := [[array(1..bound[x] $ x in X) $ i=1..n] $ j=0..soldim];
  needed := _mult(bound[x] $ x in X);
  liinalg::pprint(Unquoted, "Need to compute ".needed." modular linear solutions.");
  liinalg::pprint(NoNL, "Computing mudular LU-factorizations: \n");
end_proc:

//------------------------------------------------------
// works like linalg::matlinsolve
// uses CRT
// Accepts only square matrices!
//------------------------------------------------------
liinalg::nullspaceAR := proc(M) 
local Mpol, Pos, S, X, bound, bpol, denombound, i, j, l, modSol, n, needed, nn, p, pt, st, tmp, x, den, MM, bb, CP, L, U, Perm, soldim, dd, deltdrows;
save TEXTWIDTH;
begin
  X := [op(indets(M))];
  // convert the whole thing to poly-Entries
  Mpol := map(M, poly, X);
  if has(Mpol, FAIL) then error("Fuck!") end_if;
  // Square-dance
  [Mpol, deltdrows, soldim, denombound] := liinalg::matrixSquarify(Mpol, matrix([[0] $ i=1..extop(M,1)]), X);
  if Mpol=FAIL then return([]) end_if;
  nr := extop(Mpol, 1);
  nc := extop(Mpol, 2); 
  if nr <> nc then error("should not happen") end_if;
  n := nc;
  if soldim=1 then
    // we can use the non-LU-factoring matlinsolve_square_fullrank
    return([liinalg::matlinsolve_square_fullrank(Mpol, matrix([[poly(0,X)] $ i=1..n-1, [poly(1,X)]]), X, denombound)]);
  end_if;
  // maximal degree for the numerator of an coefficient of the solution
  bound := table( x = 1+_plus(max(degree(Mpol[i,j], x) $ j=1..n) $ i=1..n) $ x in X);
  liinalg::pprint(Unquoted, "The Bounds are: "._concat(expr2text(x)."=".bound[x]."  " $ x in X));
  i := -1; p := 0;
  Pos := liinalg::evalPoints(X, bound, denombound);
  //[[(-1)^i * floor((i+1)/2) $ i=1..bound[x]] $ x in X];
  modSol := [[array(1..bound[x] $ x in X) $ i=1..n] $ j=0..soldim];
  needed := _mult(bound[x] $ x in X);
  liinalg::pprint(Unquoted, "Need to compute ".needed." modular linear solutions.");
  liinalg::pprint(NoNL, "Computing mudular LU-factorizations: \n");
  st := time();
  nn := 0.0;
  TEXTWIDTH := 100000000;
  L := array(1..bound[x] $ x in X);
  U := array(1..bound[x] $ x in X);
  Perm := array(1..bound[x] $ x in X);
  CP := combinat::cartesianProduct(bound[x] $ x in X);
  for l in CP do
    nn := nn + 1.0;
    liinalg::pprint(NoNL, stringlib::formatf(100*nn/needed, 2)."% \r");
    pt := [Pos[i][l[i]] $ i=1..nops(X) ];
    if iszero(denombound(op(pt))) then error("This CAN not happen!") end_if;
    MM := matrix([[Mpol[i,j](op(pt)) $ j=1..n] $ i=1..n]);
    tmp := linalg::factorLU(MM);
    L[op(l)] := tmp[1];
    U[op(l)] := tmp[2];
    Perm[op(l)] := tmp[3];
  end_for;
  liinalg::pprint(Unquoted, "computing modular LU-factorizations took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  liinalg::pprint(Unquoted, "Need to compute ".needed." modular linear solutions ".soldim." times.");
  st := time();
  for dd from 1 to soldim do
    liinalg::pprint(NoNL, "Computing modular solutions ".dd.": \n");
    nn := 0.0;
    for l in CP do
      nn := nn + 1.0;
      liinalg::pprint(NoNL, stringlib::formatf(100*nn/needed, 2)."% \r");
      pt := [Pos[i][l[i]] $ i=1..nops(X) ];
      tmp := [0  $ i=1..n-soldim, _if(dd=i,1,0) $ i=1..soldim];
      bb := matrix([[tmp[i]] $ i=1..n ]);
      tmp := linalg::matlinsolveLU(L[op(l)], U[op(l)], bb);
      den := denombound(op(pt));
      for i from 1 to n do modSol[dd][i][op(l)] := den/denom(tmp[i,1])*numer(tmp[i,1]) end_for;
    end_for;
  end_for;
  liinalg::pprint(Unquoted, "solving modular linear systems took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  denombound := expr(denombound);
  st := time():
  liinalg::pprint(Unquoted, "interpolating...");
  S := [matrix([[interpolate(Pos, modSol[dd][i], X)] $ i=1..n]) $ dd=1..soldim];
  //res := (interpolate(Pos, modDet, X));
  liinalg::pprint(Unquoted, "interpolating took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
//  return (res);
  return(map(S, (m)->map(m, (mm)->(expr(mm)/denombound))));
end_proc:

//------------------------------------------------------
// works like linalg::matlinsolve
// uses CRT
// Accepts only square matrices!
//------------------------------------------------------
liinalg::matlinsolve_square_fullrank := proc(M, b, X, denombound) 
local Mpol, Pos, S,  bound, bpol, i, j, l, modSol, n, needed, nn, p, pt, st, tmp, x, den, MM, bb, CP, L, U, Perm, soldim, dd, deltdrows;
save TEXTWIDTH;
begin
  n := extop(M,1);
  // maximal degree for the numerator of an coefficient of the solution
  bound := table( x = 1+_plus(max(degree(M[i,j], x) $ j=1..n, degree(b[i,1], x)) $ i=1..n) $ x in X);
  liinalg::pprint(Unquoted, "The Bounds are: "._concat(expr2text(x)."=".bound[x]."  " $ x in X));
  // worst possible denominator
  // st := time():
  // liinalg::pprint(Unquoted, "--- Start Computing Denominator ---");
  // denombound := poly(expr(liinalg::det(M, X)), X);
  // liinalg::pprint(Unquoted, "--- Finished Computing Denominator in ".stringlib::formatf((time()-st)/1000.0,2)." sec. ---");
  i := -1; p := 0;
  Pos := liinalg::evalPoints(X, bound, denombound);
  //[[(-1)^i * floor((i+1)/2) $ i=1..bound[x]] $ x in X];
  modSol := [array(1..bound[x] $ x in X) $ i=1..n];
  needed := _mult(bound[x] $ x in X);
  liinalg::pprint(Unquoted, "Need to compute ".needed." modular linear solutions.");
  liinalg::pprint(NoNL, "Computing modular solutions: \n");
  st := time();
  nn := 0.0;
  TEXTWIDTH := 100000000;
  CP := combinat::cartesianProduct(bound[x] $ x in X);
  for l in CP do
    nn := nn + 1.0;
    liinalg::pprint(NoNL, stringlib::formatf(100*nn/needed, 2)."% \r");
    pt := [Pos[i][l[i]] $ i=1..nops(X) ];
    if iszero(denombound(op(pt))) then error("This CAN not happen!") end_if;
    MM := matrix([[M[i,j](op(pt)) $ j=1..n] $ i=1..n]);
    bb := matrix([b[i,1](op(pt))  $ i=1..n ]);
    tmp := linalg::matlinsolve(MM, bb);
    den := denombound(op(pt));
    for i from 1 to n do modSol[i][op(l)] := den/denom(tmp[i,1])*numer(tmp[i,1]) end_for;
  end_for;
  liinalg::pprint(Unquoted, "solving modular linear systems took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  denombound := expr(denombound);
  st := time():
  liinalg::pprint(Unquoted, "interpolating...");
  S := matrix([[interpolate(Pos, modSol[i], X)] $ i=1..n]);
  liinalg::pprint(Unquoted, "interpolating took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  return(map(S, (m)->(expr(m)/denombound)));
end_proc:

liinalg::evalPoints := proc(X, bound, deet)
local x, i, l, Pos, J, OK, pt, st;
begin
  liinalg::pprint(Unquoted, "Begin Searching for good evaluation points.");
  st := time():
  Pos := [[(-1)^i * floor((i)/2) $ i=1..bound[x]] $ x in X];
  OK := FALSE;
  J := [ bound[x] $ x in X];
  while not OK do
    OK := TRUE;
    for l in combinat::cartesianProduct(bound[x] $ x in X) do
      pt := [Pos[i][l[i]] $ i=1..nops(X) ];
      if iszero((deet(op(pt)))) then
        liinalg::pprint(Unquoted, "found zero of determinant: ".expr2text(pt));
        OK := FALSE;
        J := map(J, _plus, 1);
        for i from 1 to nops(X) do
          Pos[i][l[i]] := (-1)^J[i] * floor((J[i]+1)/2);
        end_for;
        break;
      end_if;
    end_for; 
  end_while;
  liinalg::pprint(Unquoted, "Search took ".stringlib::formatf((time()-st)/1000.0,2)." sec.");
  return(Pos) 
end_proc:

//------------------------------------------------------
// determinant for matrices with univariate polynomial
// coefficients
//------------------------------------------------------
liinalg::det := proc(M, X)
local MM, Pos, x, bound, i, j, modDet, n, p, l, needed, nn, pt, res, st;
save TEXTWIDTH;
begin
  n := extop(M,1);
  if args(0) = 1 then
    X := [op(indets(M))];
    MM := map(M, (m) -> poly(m, X));
  else
    MM := M;
  end_if;
  if has(M, FAIL) or n <> extop(M,2) then error ("Didn't work out!!") end_if;
  bound := table( x = min(1+_plus(max(degree(MM[i,j], x) $ j=1..n) $ i=1..n), 1+_plus(max(degree(MM[i,j], x) $ i=1..n) $ j=1..n)) $ x in X);
  liinalg::pprint(Unquoted, "The Bounds are: "._concat(expr2text(x)."=".bound[x]."  " $ x in X));
  Pos := [[(-1)^j * floor((j)/2) + bound[x] $ j=1..bound[x]] $ x in X];
  i := -1; p := 0;
  if has(MM, FAIL) then
    error("need univariate polynomial coefficients");
  end_if;
  modDet := array(1..bound[x] $ x in X);
  needed := _mult(bound[x] $ x in X);
  liinalg::pprint(Unquoted, "Need to compute ".needed." modular determinants.");
  liinalg::pprint(NoNL, "Computing modular determinants: \n");
  st := time();
  nn := 0.0;
  TEXTWIDTH := 100000000;
  for l in combinat::cartesianProduct(bound[x] $ x in X) do
    nn := nn + 1.0;
    liinalg::pprint(NoNL, stringlib::formatf(100*nn/needed, 2)."% \r");
    pt := [Pos[i][l[i]] $ i=1..nops(X) ];
    modDet[op(l)] := linalg::det(matrix([[MM[i,j](op(pt)) $ j=1..n] $ i=1..n]));
  end_for;
  liinalg::pprint(Unquoted, "modular determinants took ".stringlib::formatf((time()-st)/1000.0,2)."sec.");
  st := time():
  liinalg::pprint(Unquoted, "interpolating...");
  res := (interpolate(Pos, modDet, X));
  liinalg::pprint(Unquoted, "interpolating took ".stringlib::formatf((time()-st)/1000.0,2)."sec.");
  return (res);
end_proc:

liinalg::pprint := ()->FAIL:

//------------------------------------------------------
// determinant for matrices with univariate rational 
// function coefficients
//------------------------------------------------------
liinalg::rdet := proc(M)
local MM, d, dd, X, i, j, n;
begin
  X := op(indets(M));
  if nops(X) <> 1 then error ("Univariate, no parameters!") end_if;
  n := extop(M,1);
  d := [lcm(denom(M[i,j]) $ j=1..n) $ i=1..n];
  MM := matrix([[normal(M[i,j]*d[i]) $ j=1..n] $ i=1..n ]);
  dd := liinalg::det(MM);
  normal(expr(dd)/_mult(op(d)));
end_proc:

null():
