(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     13200,        349]
NotebookOptionsPosition[     12681,        327]
NotebookOutlinePosition[     13058,        344]
CellTagsIndexPosition[     13015,        341]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.414154821781322*^9, 3.414154823316649*^9}, {
   3.414155153356977*^9, 3.414155153968725*^9}, 3.4141583578650913`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RandPoly", "[", 
   RowBox[{"degree_", ",", " ", "terms_", ",", " ", "X_"}], "]"}], " ", ":=", 
  " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"l1", ",", " ", "l2"}], "}"}], ",", " ", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"l1", " ", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Random", "[", 
         RowBox[{"Integer", ",", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1000"}], ",", " ", "1000"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "terms"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"l2", " ", "=", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Random", "[", 
           RowBox[{"Integer", ",", " ", 
            RowBox[{"{", 
             RowBox[{"0", ",", " ", 
              RowBox[{"degree", "-", "1"}]}], "}"}]}], "]"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"terms", "-", "1"}]}], "}"}]}], "]"}], ",", "degree"}], 
       "]"}]}], ";", "  ", "\[IndentingNewLine]", 
     RowBox[{"Inner", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"#1", "*", 
          RowBox[{"X", "^", "#2"}]}], ")"}], "&"}], ",", "l1", ",", "l2", ",",
        " ", "Plus"}], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LiinearSolve", "[", 
   RowBox[{"M_", ",", " ", "b_", ",", " ", "X_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "l", ",", "bound", ",", " ", "i", ",", " ", "det", ",", " ", "sol", ",", 
      " ", "MM", ",", " ", "bb", ",", " ", "p", ",", " ", "modsols", ",", " ",
       "n"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"l", " ", "=", " ", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"n", "=", " ", 
      RowBox[{"Length", "[", "M", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"bound", " ", "=", " ", 
      RowBox[{"Plus", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Exponent", "[", 
                RowBox[{"#1", ",", "X"}], "]"}], "&"}], " ", "/@", " ", 
              "#1"}], ")"}], "//", "Max"}], ")"}], "&"}], "/@", "M"}], 
        ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"i", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"modsols", " ", "=", " ", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"While", "[", 
          RowBox[{
           RowBox[{"0", "\[Equal]", 
            RowBox[{"(", 
             RowBox[{"det", " ", "=", " ", 
              RowBox[{"Det", "[", 
               RowBox[{"MM", "=", 
                RowBox[{"(", 
                 RowBox[{"M", "/.", 
                  RowBox[{"X", "\[Rule]", " ", 
                   RowBox[{"(", 
                    RowBox[{"p", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", "i"}], "*", 
                    RowBox[{"Floor", "[", 
                    RowBox[{"i", "/", "2"}], "]"}]}]}], ")"}]}]}], ")"}]}], 
               "]"}]}], ")"}]}], ",", " ", 
           RowBox[{"i", "=", 
            RowBox[{"i", "+", "1"}]}]}], " ", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"sol", " ", "=", " ", 
          RowBox[{"LinearSolve", "[", 
           RowBox[{"MM", ",", " ", 
            RowBox[{"(", 
             RowBox[{"b", "/.", 
              RowBox[{"X", "\[Rule]", " ", "p"}]}], ")"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"sol", " ", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Numerator", "[", "#1", "]"}], "*", 
              RowBox[{"det", "/", 
               RowBox[{"Denominator", "[", "#1", "]"}]}]}], ")"}], "&"}], " ",
            "/@", " ", "sol"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"i", " ", "=", " ", 
          RowBox[{"i", "+", "1"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"p", ",", "det", ",", " ", "sol"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"k", ",", "0", ",", "bound"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"det", " ", "=", " ", 
      RowBox[{"InterpolatingPolynomial", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"#1", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
             RowBox[{"#1", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ")"}], "&"}], "/@", 
         "modsols"}], ",", " ", "X"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"InterpolatingPolynomial", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#1", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"#1", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "&"}], "/@", 
             "modsols"}], ",", " ", "X"}], "]"}], ")"}], "/", "det"}], "}"}], 
       ",", " ", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Deet", "[", 
   RowBox[{"M_", ",", " ", "X_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bound", ",", " ", "i", ",", " ", "moddet"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"bound", " ", "=", " ", 
      RowBox[{"Plus", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Exponent", "[", 
                RowBox[{"#1", ",", "X"}], "]"}], "&"}], " ", "/@", " ", 
              "#1"}], ")"}], "//", "Max"}], ")"}], "&"}], "/@", "M"}], 
        ")"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"moddet", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], "^", "i"}], "*", 
           RowBox[{"Floor", "[", 
            RowBox[{"i", "/", "2"}], "]"}]}], ",", " ", 
          RowBox[{"Det", "[", 
           RowBox[{"MM", "=", 
            RowBox[{"(", 
             RowBox[{"M", "/.", 
              RowBox[{"X", "\[Rule]", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"-", "1"}], ")"}], "^", "i"}], "*", 
                RowBox[{"Floor", "[", 
                 RowBox[{"i", "/", "2"}], "]"}]}]}]}], ")"}]}], "]"}]}], 
         "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "bound"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"InterpolatingPolynomial", "[", 
      RowBox[{"moddet", ",", " ", "X"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"d", " ", "=", " ", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t", " ", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "30"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"RandPoly", "[", 
        RowBox[{"d", ",", "t", ",", "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"b", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RandPoly", "[", 
       RowBox[{"d", ",", "t", ",", "x"}], "]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.414144877990076*^9, 3.4141448924035254`*^9}, {
   3.414144926169696*^9, 3.4141449521070538`*^9}, {3.414145049869172*^9, 
   3.4141450843205357`*^9}, {3.414145132959166*^9, 3.4141451880997553`*^9}, {
   3.414153661930332*^9, 3.414153711024578*^9}, {3.414153798288637*^9, 
   3.414153821863256*^9}, {3.414154632155525*^9, 3.414154636716262*^9}, {
   3.414154669710041*^9, 3.414154722805407*^9}, {3.414154775798482*^9, 
   3.414154800506095*^9}, {3.414154845231439*^9, 3.414154858318987*^9}, {
   3.414154889190764*^9, 3.414154996083291*^9}, {3.414155029357712*^9, 
   3.414155044407316*^9}, {3.414155105646096*^9, 3.414155147883791*^9}, {
   3.414155239972294*^9, 3.414155244834777*^9}, {3.41415548398785*^9, 
   3.414155508987924*^9}, {3.414158353407566*^9, 3.4141584357211523`*^9}, {
   3.414158882512312*^9, 3.4141588978623857`*^9}, {3.414159078927802*^9, 
   3.4141591148012743`*^9}, {3.414159174290019*^9, 3.4141593157567472`*^9}, {
   3.4141593893293858`*^9, 3.4141595988682747`*^9}, {3.4141596299825773`*^9, 
   3.414159659896364*^9}, {3.414159714283453*^9, 3.4141597396205883`*^9}, {
   3.41415988678442*^9, 3.414159953366053*^9}, {3.414159992472889*^9, 
   3.414160015535365*^9}, {3.414160074099859*^9, 3.4141603064860773`*^9}, {
   3.414160348575035*^9, 3.414160369335803*^9}, {3.4141604076242332`*^9, 
   3.414160574737371*^9}, {3.4141606254379873`*^9, 3.4141606282491713`*^9}, {
   3.4141606605018797`*^9, 3.4141606969989557`*^9}, {3.4141607453750153`*^9, 
   3.41416075042562*^9}, {3.414160798801282*^9, 3.414160810550848*^9}, {
   3.414160841839345*^9, 3.414160854314274*^9}, {3.41416091352792*^9, 
   3.414160918962579*^9}, {3.414161252631536*^9, 3.414161253318301*^9}, {
   3.414161840390987*^9, 3.4141618446887417`*^9}, {3.415859993082765*^9, 
   3.4158600910092783`*^9}, {3.415860129173133*^9, 3.415860184837232*^9}, {
   3.4158602201004343`*^9, 3.4158603185521803`*^9}, 3.4158604167574387`*^9, {
   3.4158604514689407`*^9, 3.4158604516542597`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"d1", " ", "=", " ", 
    RowBox[{"Deet", "[", 
     RowBox[{"M", ",", "X"}], "]"}]}], ";"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"d2", " ", "=", " ", 
    RowBox[{"Det", "[", "M", "]"}]}], ";"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Together", "[", 
  RowBox[{"d1", "-", "d2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.414161280650928*^9, 3.4141612925811872`*^9}, {
  3.415860190125162*^9, 3.415860198761983*^9}, {3.415860329986779*^9, 
  3.415860344752698*^9}, {3.415860408500556*^9, 3.415860409286604*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"87.17858000000001`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.415860302677063*^9, 3.4158603454913273`*^9}, {
   3.415860410505941*^9, 3.415860425659214*^9}, 3.415860541042634*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"88.48481700000002`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.415860302677063*^9, 3.4158603454913273`*^9}, {
   3.415860410505941*^9, 3.415860425659214*^9}, 3.4158606295090313`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.415860302677063*^9, 3.4158603454913273`*^9}, {
   3.415860410505941*^9, 3.415860425659214*^9}, 3.415860629512678*^9}]
}, Open  ]]
},
WindowSize->{2104, 1332},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"6.0 for Mac OS X x86 (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 166, 2, 40, "Input"],
Cell[737, 25, 10641, 265, 688, "Input"],
Cell[CellGroupData[{
Cell[11403, 294, 617, 14, 87, "Input"],
Cell[12023, 310, 233, 4, 40, "Output"],
Cell[12259, 316, 235, 4, 40, "Output"],
Cell[12497, 322, 168, 2, 40, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
